ancova <- function(x,P1=0.05,P2=0.05,P3=0.05,t.test=TRUE,Pt=0.05){

#>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<
#>>>>>                              <<<<<
#>>>>>    Analysis of covariance    <<<<<
#>>>>>                              <<<<<
#>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<                           

   h <- 0
   g <- table(x[,ncol(x)])
   E <- NULL
   EE <- NULL
      while(h < max(x[,ncol(x)])){
         if(h == 0){
            a <- x[1:g[1],1:ncol(x)]
    
               i <- 1
               j <- 1
               A <- NULL
               k <- ncol(a)-1
                  while(i < k) {
                     while(j < k){
                        SS1 <- sum(a[,i]*a[,j])-
                               ((sum(a[,i])*sum(a[,j]))/sum(table(a[,ncol(a)])))
                        A <- c(append(A,SS1))
                        j <- j + 1
                     }
                     i <- i + 1
                     j <- 1
                  }    
     B <- matrix(A,nrow=ncol(a)-2,ncol=ncol(a)-2)

      i <-1
      k <- ncol(a)-1
      C <- NULL
         while(i < k){
            SS2 <- sum(a[,i]*a[,ncol(a)-1])-
                   ((sum(a[,i])*sum(a[,ncol(a)-1]))/sum(table(a[,ncol(a)])))
            C <- append(C,SS2)
            D <- matrix(C,byrow=T,ncol=1)
            i <- i + 1
         }
   
      SSy1 <- sum(a[,ncol(x)-1]^2)-((sum(a[,ncol(x)-1]))^2/sum(table(a[,ncol(x)])))
            
            }
         else{
            xx <- x[sum(g[1:h])+1:g[h+1],1:ncol(x)]

               i <- 1
               j <- 1
               AA <- NULL
               k <- ncol(x)-1
                  while(i < k) {
                     while(j < k){
                        SS1 <- sum(xx[,i]*xx[,j])-
                               ((sum(xx[,i])*sum(xx[,j]))/sum(table(xx[,ncol(x)])))
                        AA <- append(AA,SS1)
                        j <- j + 1
                     }
                         i <- i + 1
                     j <- 1
                            } 

                      E <- append(E,AA)


               i <-1
               k <- ncol(x)-1
               CC <- NULL
                  while(i < k){
                     SS2 <- sum(xx[,i]*xx[,ncol(x)-1])-
                            ((sum(xx[,i])*sum(xx[,ncol(x)-1]))/sum(table(xx[,ncol(x)])))
                     CC <- append(CC,SS2)
                     i <- i + 1
                 }

              EE <- append(EE,CC)
           }

      h <- h + 1

      } 

   BB <- matrix(E,nrow=ncol(x)-2,ncol=(ncol(x)-2)*(max(x[,ncol(x)]-1)))
   a <-  matrix(0,nrow=ncol(x)-2,ncol=ncol(x)-2)
      for(i in  1:(max(x[,ncol(x)])-1)){
         BBB <- BB[(1:(ncol(x)-2)),(1+(i-1)*(ncol(x)-2)):((1+(i-1)*(ncol(x)-2))+(ncol(x)-3))]
         a <- a+BBB
         aa<- a+B          
      }

   b <-  matrix(0,nrow=ncol(x)-2,ncol=1)       
   CC <- matrix(EE,nrow=ncol(x)-2,ncol=(max(x[,ncol(x)]))-1)
      for(i in  1:(max(x[,ncol(x)])-1)){
         CCC <- CC[(1:(ncol(x)-2)),i]
         b <- b+CCC
         bb<- b+D
      }

   SSy2 <- NULL
      for(h in 1:(max(x[,ncol(x)])-1)) {    
         xx <- x[sum(g[1:h])+1:g[h+1],1:ncol(x)]
         SSy <- sum(xx[,ncol(x)-1]^2)-((sum(xx[,ncol(x)-1]))^2/sum(table(xx[,ncol(x)])))
         SSy2 <- append(SSy2,SSy) 
      }

   BB <- matrix(E,nrow=ncol(x)-2,ncol=(ncol(x)-2)*(max(x[,ncol(x)]-1)))
   CC <- matrix(EE,nrow=ncol(x)-2,ncol=(max(x[,ncol(x)]))-1)
   DD <- NULL
      for(i in  1:(max(x[,ncol(x)])-1)){
         BBB <- BB[(1:(ncol(x)-2)),(1+(i-1)*(ncol(x)-2)):((1+(i-1)*(ncol(x)-2))+(ncol(x)-3))]
         CCC <- CC[(1:(ncol(x)-2)),i]
         reg2 <- solve(BBB,CCC) 
         DD <- append(DD,reg2)
      }
    
   reg1 <- solve(B,D)
   Se1 <- SSy1-sum(reg1*D)  
    
   FF <- matrix(DD,nrow=ncol(x)-2,ncol=max(x[,ncol(x)])-1)
   CC <- matrix(EE,nrow=ncol(x)-2,ncol=(max(x[,ncol(x)]))-1)
   HH <- NULL
      for(i in 1:(max(x[,ncol(x)])-1)){
         GG <- sum(FF[,i]*CC[,i])
         HH <- append(HH,GG) 
      }

   JJ <- NULL    
      for(i in 1:(max(x[,ncol(x)])-1)){
         II <- SSy2[i]-HH[i]
         JJ <- sum(append(JJ,II))
      }

   Se <- Se1+JJ
   SSyy <- SSy1+sum(SSy2)
   regression <- solve(aa,bb)

   total1.df <- (length(x[,1]))-(max(x[,ncol(x)])+(ncol(x)-2))
   total1.SS <- SSyy-sum(regression*bb)
   total1.MS <-  total1.SS/total1.df  
 
   intercept1.df <- (max(x[,ncol(x)])-1)*(ncol(x)-2)
   intercept1.SS <- (SSyy-sum(regression*bb))-Se
   intercept1.MS <- intercept1.SS/intercept1.df

   error1.df <- (length(x[,1]))-((ncol(x)-2+1)*max(x[,ncol(x)]))
   error1.SS <- Se
   error1.MS <- error1.SS/error1.df

   f1 <- pf(intercept1.MS/error1.MS,intercept1.df,error1.df,lower.tail=FALSE)   

   col1.1 <- c(intercept1.SS,intercept1.df,intercept1.MS)
   col1.2 <- c(error1.SS,error1.df,error1.MS)
   col1.3 <- c(total1.SS,total1.df,total1.MS)
   table1.1 <- rbind(col1.1,col1.2,col1.3)
   colnames(table1.1) <- c("SS","df","MS")   
   rownames(table1.1) <- c("difference of regression coefficient","residual","total")
   result1.1 <- c(F.Value=intercept1.MS/ error1.MS,P.Value=f1)

   if(f1 <= P1){   
      list(result=result1.1)
      stop("H1:All slopes are not equal. So,you can not apply ancova!")

   }

   else{
      result1.2 <- "H0:All slopes are equal." 
   }


   i <- 1
   j <- 1
   A <- NULL
   k <- ncol(x)-1
      while(i < k) {
         while(j < k){
            SS1 <- sum(x[,i]*x[,j])-
                 ((sum(x[,i])*sum(x[,j]))/sum(table(x[,ncol(x)])))
            A <- append(A,SS1)
            j <- j + 1
         }
         B <- matrix(A,nrow=ncol(x)-2,ncol=ncol(x)-2)
         i <- i + 1
         j <- 1
      }    
     
   i <-1
   k <- ncol(x)-1
   C <- NULL
      while(i < k){
         SS2 <- sum(x[,i]*x[,ncol(x)-1])-
                ((sum(x[,i])*sum(x[,ncol(x)-1]))/sum(table(x[,ncol(x)])))
         C <- append(C,SS2)
         D <- matrix(C,byrow=T,ncol=1)
         i <- i + 1
      }

   SS3 <- sum(x[,ncol(x)-1]^2)-((sum(x[,ncol(x)-1]))^2/sum(table(x[,ncol(x)])))
   reg1 <- solve(B,D)
   ss  <- sum(reg1*D)


  if(ncol(x)-2 == 1){
    mx <- mean(x[,1])
    my <- mean(x[,2])
    mxi <- tapply(x[,1],x[,3],mean)
    myi <- tapply(x[,2],x[,3],mean)
    vxi <- tapply(x[,1],x[,3],var)
    vyi <- tapply(x[,2],x[,3],var)
    g <- table(x[,3])
    SSwx <- sum((g-1)*vxi)
    SSwy <- sum((g-1)*vyi)

    i <- 1
    SPw <- 0 
  while(i <= max(x[,3])){
     if(i == 1){
        a <- c(1:g[1])
     }
     else {
        a <-  c((sum(g[1:i-1])+1):sum(g[1:i]))
     }
    SPw <- SPw + sum((g[i]-1)*cov(x[a,1],x[a,2]))  
    i<-i+1    
  }

   df1 <-1
   df2 <-length(x[,1])-max(x[,ncol(x)])-1
   df3 <- df1+df2
   Sum1 <- SPw^2/SSwx
   Sum2 <- SSwy-Sum1
   Sum3 <- Sum1+Sum2
   Mean1 <- Sum1
   Mean2 <- ((SSwy*SSwx)-SPw^2)/(df2*SSwx)
   Mean3 <- Mean1+Mean2 
   F2 <- Mean1/Mean2
   f2 <- pf(F2, df1, df2, lower.tail=FALSE)
   col2.1 <- c(Sum1,df1,Mean1)
   col2.2 <- c(Sum2,df2,Mean2)
   col2.3 <- c(Sum3,df3,Mean3)
   table2.1 <- rbind(col2.1,col2.2,col2.3)
   colnames(table2.1) <- c("SS","df","MS")   
   rownames(table2.1) <- c("regression","residual","total")
   result2.1 <- c(F.Value=F2,P.Value=f2)

    z <- x

   if(f2 >= P2){    
      stop("H0:All slopes are 0. So,you may use anova.")
      }

   else{
      result2.2 <- "H1:All slopes are not 0." 
      }
   }

   else{
   
   dif2.df <- ncol(x)-2
   dif2.SS <- ss
   dif2.MS <- dif2.SS/dif2.df 

   total2.df <- (length(x[,1])-(ncol(x)-2)-1)+dif2.df
   total2.SS <- SS3
   total2.MS <- total2.SS/total1.df

   error2.df <- length(x[,1])-(ncol(x)-2)-1 
   error2.SS <- total2.SS-dif2.SS
   error2.MS <- error2.SS/error2.df

   f2 <- pf(dif2.MS/ error2.MS,dif2.df,error2.df,lower=FALSE)   

   col2.1 <- c(dif2.SS,dif2.df,dif2.MS)
   col2.2 <- c(error2.SS,error2.df,error2.MS)
   col2.3 <- c(total2.SS,total2.df,total2.MS)
   table2.1 <- rbind(col2.1,col2.2,col2.3)
   colnames(table2.1) <- c("SS","df","MS")   
   rownames(table2.1) <- c("regression","residual","total")
   result2.1 <- c(F.Value=dif2.MS/error2.MS,P.Value=f2)

   if(f2 >= P2){    
      stop("H0:All slopes are 0. So,you may use anova.")
      }

   else{
      result2.2 <- "H1:Among all slopes, at least one is not 0." 
      }

   RR <- 1-dif2.SS/total2.SS
   S <- error2.MS
   c <- solve(B)


  if(t.test == TRUE){

   i <- 1
   T <- NULL
   while(i <= ncol(x)-2 ){
      t <-  reg1[i,1]/(sqrt(c[i,i]*S))
      T <- append(T,t)
      i <- i + 1       
   }

   i <-1
   P <- NULL
      while(i <= ncol(x)-2){    
        pt <- pt(abs(T[i]),error1.df,lower.tail=FALSE)
        P <- append(P,pt*2) 
        i <- i + 1
      }

   X <- NULL
    for(i in 1:length(P)){
      if(P[i] <= Pt){
      X <- cbind(X,x[1:length(x[,ncol(x)]),i])
     } 
     }

    z <- cbind(X,x[1:length(x[,ncol(x)]),ncol(x)-1],x[1:length(x[,ncol(x)]),ncol(x)])

   }

   else{

   z <- x

   }

   R2  <- (dif2.SS/total2.SS)
   Ra2 <- ((nrow(x)-1)*R2-(ncol(x)-2))/(nrow(x)-(ncol(x)-2)-1)
}


   h <- 0
   g <- table(z[,ncol(z)])
   E <- NULL
   EE <- NULL
      while(h < max(z[,ncol(z)])){
         if(h == 0){
            a <- z[1:g[1],1:ncol(z)]
    
               i <- 1
               j <- 1
               A <- NULL
               k <- ncol(a)-1
                  while(i < k) {
                     while(j < k){
                        SS1 <- sum(a[,i]*a[,j])-
                               ((sum(a[,i])*sum(a[,j]))/sum(table(a[,ncol(a)])))
                        A <- append(A,SS1)
                        j <- j + 1
                     }
                     B <- matrix(A,nrow=ncol(a)-2,ncol=ncol(a)-2)
                     i <- i + 1
                     j <- 1
                  }    
     
      i <-1
      k <- ncol(a)-1
      C <- NULL
         while(i < k){
            SS2 <- sum(a[,i]*a[,ncol(a)-1])-
                   ((sum(a[,i])*sum(a[,ncol(a)-1]))/sum(table(a[,ncol(a)])))
            C <- append(C,SS2)
            D <- matrix(C,byrow=T,ncol=1)
            i <- i + 1
         }
   
      SSy1 <- sum(a[,ncol(z)-1]^2)-((sum(a[,ncol(z)-1]))^2/sum(table(a[,ncol(z)])))
            
            }
         else{
            xx <- z[sum(g[1:h])+1:g[h+1],1:ncol(z)]

               i <- 1
               j <- 1
               AA <- NULL
               k <- ncol(z)-1
                  while(i < k) {
                     while(j < k){
                        SS1 <- sum(xx[,i]*xx[,j])-
                               ((sum(xx[,i])*sum(xx[,j]))/sum(table(xx[,ncol(z)])))
                        AA <- append(AA,SS1)
                        j <- j + 1
                     }
                     i <- i + 1
                     j <- 1
                  }       
          E <- append(E,AA)
 
               i <-1
               k <- ncol(z)-1
               CC <- NULL
                  while(i < k){
                     SS2 <- sum(xx[,i]*xx[,ncol(z)-1])-
                            ((sum(xx[,i])*sum(xx[,ncol(z)-1]))/sum(table(xx[,ncol(z)])))
                     CC <- append(CC,SS2)
                     i <- i + 1
                 }

          EE <- append(EE,CC)
    
           }

      h <- h + 1

      } 

   BB <- matrix(E,nrow=ncol(z)-2,ncol=(ncol(z)-2)*(max(z[,ncol(z)]-1)))
   a <-  matrix(0,nrow=ncol(z)-2,ncol=ncol(z)-2)
      for(i in  1:(max(z[,ncol(z)])-1)){
         BBB <- BB[(1:(ncol(z)-2)),(1+(i-1)*(ncol(z)-2)):((1+(i-1)*(ncol(z)-2))+(ncol(z)-3))]
         a <- a+BBB
         aa<- a+B          
      }

   b <-  matrix(0,nrow=ncol(z)-2,ncol=1)       
   CC <- matrix(EE,nrow=ncol(z)-2,ncol=(max(z[,ncol(z)]))-1)
      for(i in  1:(max(z[,ncol(z)])-1)){
         CCC <- CC[(1:(ncol(z)-2)),i]
         b <- b+CCC
         bb<- b+D
      }

   SSy2 <- NULL
      for(h in 1:(max(z[,ncol(z)])-1)) {    
         xx <- z[sum(g[1:h])+1:g[h+1],1:ncol(z)]
         SSy <- sum(xx[,ncol(z)-1]^2)-((sum(xx[,ncol(z)-1]))^2/sum(table(xx[,ncol(z)])))
         SSy2 <- append(SSy2,SSy) 
      }

   BB <- matrix(E,nrow=ncol(z)-2,ncol=(ncol(z)-2)*(max(z[,ncol(z)]-1)))
   CC <- matrix(EE,nrow=ncol(z)-2,ncol=(max(z[,ncol(z)]))-1)
   DD <- NULL
      for(i in  1:(max(z[,ncol(z)])-1)){
         BBB <- BB[(1:(ncol(z)-2)),(1+(i-1)*(ncol(z)-2)):((1+(i-1)*(ncol(z)-2))+(ncol(z)-3))]
         CCC <- CC[(1:(ncol(z)-2)),i]
         reg2 <- solve(BBB,CCC) 
         DD <- append(DD,reg2)
      }
    
   reg1 <- solve(B,D)
   Se1 <- SSy1-sum(reg1*D)  
    
   FF <- matrix(DD,nrow=ncol(z)-2,ncol=max(z[,ncol(z)])-1)
   CC <- matrix(EE,nrow=ncol(z)-2,ncol=(max(z[,ncol(z)]))-1)
   HH <- NULL
      for(i in 1:(max(z[,ncol(z)])-1)){
         GG <- sum(FF[,i]*CC[,i])
         HH <- append(HH,GG) 
      }

   JJ <- NULL    
      for(i in 1:(max(z[,ncol(z)])-1)){
         II <- SSy2[i]-HH[i]
         JJ <- sum(append(JJ,II))
      }

   Se <- Se1+JJ
   SSyy <- SSy1+sum(SSy2)
   regression <- solve(aa,bb)


   total1.df <- (length(z[,1]))-(max(z[,ncol(z)])+(ncol(z)-2))
   total1.SS <- SSyy-sum(regression*bb)
   total1.MS <-  total1.SS/total1.df  
 
   intercept1.df <- (max(z[,ncol(z)])-1)*(ncol(z)-2)
   intercept1.SS <- (SSyy-sum(regression*bb))-Se
   intercept1.MS <- intercept1.SS/intercept1.df

   error1.df <- (length(z[,1]))-((ncol(z)-2+1)*max(z[,ncol(z)]))
   error1.SS <- Se
   error1.MS <- error1.SS/error1.df

   i <- 1
   j <- 1
   A <- NULL
   k <- ncol(z)-1
      while(i < k) {
         while(j < k){
            SS1 <- sum(z[,i]*z[,j])-((sum(z[,i])*sum(z[,j]))/sum(table(z[,ncol(z)])))
            A <- append(A,SS1)
            j <- j + 1
         }
            B <- matrix(A,nrow=ncol(z)-2,ncol=ncol(z)-2)
            i <- i + 1
            j <- 1
       }    
     
   i <-1
   k <- ncol(z)-1
   C <- NULL
      while(i < k){
         SS2 <- sum(z[,i]*z[,ncol(z)-1])-
                ((sum(z[,i])*sum(z[,ncol(z)-1]))/sum(table(z[,ncol(z)])))
         C <- append(C,SS2)
         D <- matrix(C,byrow=T,ncol=1)
         i <- i + 1
      }

   SS3 <- sum(z[,ncol(z)-1]^2)-((sum(z[,ncol(z)-1]))^2/sum(table(z[,ncol(z)])))
   regression1 <- solve(B,D)

   all3.df <- ncol(z)-2
   all3.SS <- ss
   all3.MS <- all3.SS/all3.df 
 
   intercept3.df <- max(z[,ncol(z)])-1
   intercept3.SS <- SS3-all3.SS-total1.SS
   intercept3.MS <- intercept3.SS/intercept3.df 

   error3.df <- total1.df
   error3.SS <- total1.SS
   error3.MS <- total1.MS

   total3.df <- intercept3.df+error3.df   
   total3.SS <- SS3-ss
   total3.MS <- intercept3.MS+error3.MS

   f3 <- pf(intercept3.MS/error3.MS,intercept3.df,error3.df,lower=FALSE)

   
   col3.2 <- c(intercept3.SS,intercept3.df,intercept3.MS)
   col3.3 <- c(error3.SS,error3.df,error3.MS)
   col3.4 <- c(total3.SS,total3.df,total3.MS)
   table3.1 <- rbind(col3.2,col3.3,col3.4)
   colnames(table3.1) <- c("SS","df","MS")   
   rownames(table3.1) <- c("difference of intercept","error","total")
   result3.1 <- c(F.Value=intercept3.MS/ error3.MS,P.Value=f3)

   if(f3 <= P3){    
      result3.2 <- "H1:All adjusted means are not equal."
   } else{
      result3.2 <- "H0:All adjusted means are equal." 
   }
   
   if(ncol(x)-2 == 1){
      list(step1=result1.2,table1=table1.1,result1=result1.1,
      step2=result2.2,table2=table2.1,result2=result2.1,
      step3=result3.2,table3=table3.1,result3=result3.1)
   } else{
      if(t.test == TRUE){ 
         list(step1=result1.2,table1=table1.1,result1=result1.1,
         step2=result2.2,table2=table2.1,result2=result2.1,P.Value=P,R2=R2,Ra2=Ra2,data=z,
         step3=result3.2,table3=table3.1,result3=result3.1)
      } else{
        list(step1=result1.2,table1=table1.1,result1=result1.1,
        step2=result2.2,table2=table2.1,result2=result2.1,R2=R2,Ra2=Ra2,
        step3=result3.2,table3=table3.1,result3=result3.1)
      }
   } #
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#
#   >>> input <<<
#             x: matrix consisted of covariates and variate and group number
#            P1: significance level for test of parallelism of regression 
#            P2: significance level for test of significant of regression    
#            P3: significance level for analysis of covariance
#        t.test: if you apply t-test of each covariates,input "t.test=TRUE".
#                else input "t.test=FALSE".
#            Pt: significance level for t-test of each covariates
#
#   >>> output <<<
#         step1: result of test of parallelism of regression
#        table1: analysis of variance table for test of parallelism of regression
#       result1: F-value and p-value of test of parallelism of regression
#
#         step2: result of test of significant of regression
#        table2: analysis of variance table for test of significant of regression
#       result2: F-value and p-value of test of significant of regression
#       P.Value: p-value of t-test of each covariates
#            R2: multiple correlation coefficient
#           Ra2: multiple correlation coefficient adjusted for DF
#          data: data consisted of covariates which became significant by t-test of each covariates
#
#         step3: result of analysis of covariance
#        table3: analysis of variance table for analysis of covariance
#       result3: F-value and p-value of analysis of covariance
#
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#                                                03/20/04  by  Hirakawa
}
